/* main.h
 *
 */


#ifndef HAVE_MAIN_H
#define HAVE_MAIN_H


#include "file.h"
#include "prefs.h"

#define GLADE_DIR               PACKAGE G_DIR_SEPARATOR_S "glade"
#define IMPORT_DIR              PACKAGE G_DIR_SEPARATOR_S "import"
#define EXPORT_DIR              PACKAGE G_DIR_SEPARATOR_S "export"

#define F_GLADE_MAIN            GLADE_DIR G_DIR_SEPARATOR_S "main.glade"
#define F_GLADE_EDITOR          GLADE_DIR G_DIR_SEPARATOR_S "editor.glade"
#define F_GLADE_QUIZ            GLADE_DIR G_DIR_SEPARATOR_S "quiz.glade"
#define F_GLADE_PROPERTIES      GLADE_DIR G_DIR_SEPARATOR_S "properties.glade"
#define F_GLADE_PREFERENCES     GLADE_DIR G_DIR_SEPARATOR_S "preferences.glade"
#define F_GLADE_FIND            GLADE_DIR G_DIR_SEPARATOR_S "find.glade"

#define F_ICON                  "ignuit.png"
#define F_IMG_BTN_KNOWN         PACKAGE G_DIR_SEPARATOR_S "known.png"
#define F_IMG_BTN_UNKNOWN       PACKAGE G_DIR_SEPARATOR_S "unknown.png"
#define F_IMG_BTN_FLIP          PACKAGE G_DIR_SEPARATOR_S "flip.png"
#define F_IMG_BTN_QUIZ_1        PACKAGE G_DIR_SEPARATOR_S \
                                "box-start-quiz-24.png"


typedef enum {

    QUIZ_ALL_CATEGORIES = 0,
    QUIZ_CURRENT_CATEGORY,
    QUIZ_N_CATEGORY_SELECTIONS

} QuizSelectCategories;


typedef enum {

    QUIZ_ALL_CARDS = 0,
    QUIZ_NEW_CARDS,
    QUIZ_EXPIRED_CARDS,
    QUIZ_NEW_AND_EXPIRED_CARDS,
    QUIZ_SELECTED_CARDS,
    QUIZ_N_CARD_SELECTIONS

} QuizSelectCards;


typedef struct _QuizInfo QuizInfo;

struct _QuizInfo {

    QuizSelectCategories  category_selection;
    QuizSelectCards       card_selection;
    gboolean              reverse;

};


typedef struct _Ignuit Ignuit;

struct _Ignuit {

    GnomeProgram *program;

    GDate        *today;
    GRand        *grand;

    File         *file;
    Prefs        *prefs;

    QuizInfo     quizinfo;

    /* Main window */

    GtkWidget    *app;

    GtkTreeView  *treev_cat;
    GtkTreeView  *treev_card;
    GnomeAppBar  *appbar;

    GtkWidget    *m_remove_category;
    GtkWidget    *b_remove_category;
    GtkWidget    *m_add_card;
    GtkWidget    *b_add_card;
    GtkWidget    *m_find;
    GtkWidget    *t_find;
    GtkWidget    *m_start_quiz;
    GtkWidget    *t_start_quiz;
    GtkWidget    *m_find_all;
    GtkWidget    *m_view_trash;
    GtkWidget    *m_switch_sides;
    GtkWidget    *m_reset_stats;

    GList        *recent_search_terms;

};


gboolean    date_today (GDate *date);


#endif /* HAVE_MAIN_H */

